package com.casic.dcms.vm;

import androidx.lifecycle.MutableLiveData;

import com.casic.dcms.model.CaseNextNodeBean;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.pengxh.androidx.lite.callback.OnObserverCallback;
import com.pengxh.androidx.lite.vm.BaseViewModel;
import com.pengxh.androidx.lite.vm.ObserverSubscriber;

import java.io.IOException;

import okhttp3.ResponseBody;
import rx.Observable;

public class NodeViewModel extends BaseViewModel {
    private final Gson gson = new Gson();
    public MutableLiveData<CaseNextNodeBean> nodeModel = new MutableLiveData<>();

    public void obtainNextNode(String caseState) {
        Observable<ResponseBody> observable = RetrofitServiceManager.getProcessNextNodeResult(caseState);
        ObserverSubscriber.addSubscribe(observable, new OnObserverCallback() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        CaseNextNodeBean resultBean = gson.fromJson(response, new TypeToken<CaseNextNodeBean>() {
                        }.getType());
                        nodeModel.setValue(resultBean);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
